from typing import Any, Union, Iterable, Literal, Optional
class Advance_dict(dict):
      """
      subclass of dict.
      """
      def list_keys(self):
            """return a list of the dictionary keys"""
            return [k for k in self.keys()]  
                      
      def list_values(self):
            """return a list of the dictionary values"""
            return [v for v in self.values()]
      
      def combine(self, self_2: Union['Advance_dict', dict]):
            """same as .update() but keep the values of the first dict."""
            for key, value in self_2.items(): 
                  if key not in self:
                        self.update({key : value})
            return None

      def update_index(self, value: Any = None, index: int = 0):
            """update a specefic item's value by its index or placement.

            Args:
            value (Any, optional): the new value you want to update to the key. Defaults to None.
            index (int, optional): the placement(index) of the item . Defaults to 0
            """
            if len(self.list_keys()) == 0: 
                  return None
            else:
                  key = self.list_keys()[index]
                  self.update({key : value})
                  return self

      def sort(self) -> None:
            """sort the dict by keys"""
            dict_ = {}
            dict_keys = self.list_keys(); dict_keys.sort()
            for key in dict_keys:
                  dict_.update({key: self[key]})
            self.clear()
            self.update(dict_)
            
      def from_iratable(self,keys: Iterable,values: Iterable, add_keys: Iterable = None, parametre: Literal["extend_keys", "extend_values", "cut"] = "cut"): #type : ignore
            if parametre == "extend_values" and not add_keys:
                  raise(TypeError(" missing 1 required positional argument for extend_values: 'additional'"))
            largest = len(keys) if len(keys)>= len(values) else len(values)
            for i in range(largest): 
                  try:
                        self.update({keys[i] : values[i]})
                        tracker = i + 1
                  except IndexError:
                        if parametre == "extend_keys":
                              self.update({keys[i] : None})
                        elif parametre == "cut":
                              break
                        elif parametre == "extend_values":
                              self.update({add_keys[i - tracker] : values[i]})
            return self